<template>
  <el-dialog
    :modal="true"
    :show-close="false"
    :visible="true"
    :append-to-body="true"
    title="Active run!"
  >
    <div v-if="abandoning">
      <p>
        Are you sure you want to abandon this run? Please tap the letters Y E S
        below. (This is to make sure you don't butt-dial your way out of a run
        you're enjoying!)
      </p>

      <div>
        <el-button :type="typeForLetter('Y')" @click="abandon('Y')"
          >Y</el-button
        >
        <el-button :type="typeForLetter('E')" @click="abandon('E')"
          >E</el-button
        >
        <el-button :type="typeForLetter('S')" @click="abandon('S')"
          >S</el-button
        >
      </div>

      <div v-if="warning">
        {{ warning }}
      </div>
    </div>
    <div v-else>
      <span>You have an active run!</span>
    </div>

    <span slot="footer" class="dialog-footer">
      <el-button v-if="!abandoning" @click="startAbandon"
        >Abandon Run</el-button
      >
      <stateful-button v-if="!abandoning" @click="finishRun"
        >Finish Run</stateful-button
      >
      <stateful-button @click="continueRun">Continue Run</stateful-button>
    </span>
  </el-dialog>
</template>
<script>
import CarefulButton from "~/components/CarefulButton";
import { pause } from "~/lib/utils";

export default {
  components: { CarefulButton },
  data() {
    return {
      abandoning: false,
      phrase: "",
      warning: null,
    };
  },
  methods: {
    typeForLetter(letter) {
      if (this.phrase.includes(letter)) return "danger";
      return "";
    },
    startAbandon() {
      this.abandoning = true;
    },
    abandon(letter) {
      if (this.phrase.includes(letter)) {
        this.phrase = "";
        this.warn("Phrase reset, only tap each letter once");
        return;
      }
      this.phrase = this.phrase + letter;
      if (this.phrase == "YES") {
        this.warn("Abandoning!");
        this.$store.commit("run/reset");
        return;
      }
      if (this.phrase.length >= 3) {
        this.warn("Please tap Y E S, not " + this.phrase);
        this.phrase = "";
        return;
      }
    },
    async warn(warning) {
      this.warning = warning;
      await pause(5000);
      if (this.warning == warning) this.warning = null;
    },
    async finishRun() {
      await this.$store.dispatch("run/finish");
    },
    continueRun() {
      const courseId = this.$store.state.run.courseId;
      this.$router.push(`/run/course?id=${courseId}`);
    },
  },
};
</script>
